﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Controls.DragDrop;
using Telerik.Windows.Controls.GridView;
using System.Collections.ObjectModel;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.GridView;
using System.Collections;

namespace _288163_GridViewDnD
{
	/// <summary>
	/// Interaction logic for Window1.xaml
	/// </summary>
	public partial class Window1 : Window
	{
		public Window1()
		{
			InitializeComponent();
			this.radGridView1.ItemsSource = GenerateProducts();
			this.radGridView2.ItemsSource = GenerateProducts();

			RadDragAndDropManager.AddDropQueryHandler(radGridView1, RadGridView_OnDropQuery);
			RadDragAndDropManager.AddDropInfoHandler(radGridView1, RadGridView_OnDropInfo);
			RadDragAndDropManager.AddDragQueryHandler(radGridView1, OnGridViewDragQuery);
			RadDragAndDropManager.AddDragInfoHandler(radGridView1, OnGridViewDragInfo);

			RadDragAndDropManager.AddDropQueryHandler(radGridView2, RadGridView_OnDropQuery);
			RadDragAndDropManager.AddDropInfoHandler(radGridView2, RadGridView_OnDropInfo);
			RadDragAndDropManager.AddDragQueryHandler(radGridView2, OnGridViewDragQuery);
			RadDragAndDropManager.AddDragInfoHandler(radGridView2, OnGridViewDragInfo);

		}
		#region RadGridView Data Collection

		public class ProductViewModel
		{
			public string Name { get; set; }
			public string Description { get; set; }
			public decimal UnitPrice { get; set; }
		}

		private ObservableCollection<ProductViewModel> GenerateProducts()
		{
			ObservableCollection<ProductViewModel> result = new ObservableCollection<ProductViewModel>();
			for (int i = 1; i < 20; i++)
			{
				ProductViewModel product = new ProductViewModel()
				{
					Name = String.Format("Name {0}", i),
					Description = String.Format("Description {0}", i),
					UnitPrice = i * 100
				};
				result.Add(product);
			}
			return result;
		}

		#endregion

		#region DragDropEvent handlers

		//DragQuery event handler 
		private void OnGridViewDragQuery(object sender, DragDropQueryEventArgs e)
		{
			RadGridView gridView = sender as RadGridView;
			if (gridView != null)
			{
				e.Options.Payload = gridView.SelectedItem;
			}
			e.QueryResult = true;
			e.Handled = true;
		}

		//DragInfo event handler
		private void OnGridViewDragInfo(object sender, DragDropEventArgs e)
		{
			RadGridView gridView = sender as RadGridView;
			ProductViewModel draggedItem = e.Options.Payload as ProductViewModel;

			if (e.Options.Status == DragStatus.DragInProgress)
			{
				//Setting up a drag cue:
				ContentControl cue = new ContentControl();
				//Choosing a template for the items:
				cue.ContentTemplate = this.Resources["ProductTemplate"] as DataTemplate;
				cue.Content = draggedItem;
				e.Options.DragCue = cue;

			}
			else if (e.Options.Status == DragStatus.DragComplete)
			{
				//deleting the dragged item from the RadGridView
				IList source = gridView.ItemsSource as IList;
				source.Remove(draggedItem);
			}
		}

		//DropQuery event handler 
		private void RadGridView_OnDropQuery(object sender, DragDropQueryEventArgs e)
		{
			RadGridView destination = sender as RadGridView;

			if (destination != null)
			{
				e.Handled = true;
				e.QueryResult = true;
			}
		}

		//DropInfo event handler 
		private void RadGridView_OnDropInfo(object sender, DragDropEventArgs e)
		{
			RadGridView destination = sender as RadGridView;
			
			if (e.Options.Status == DragStatus.DropComplete)
			{
				GridViewCell destCell = e.Options.Destination as GridViewCell;
				if (destCell != null)
				{
					var ID = destCell.Column.Header;
				}
				(destination.ItemsSource as IList<ProductViewModel>).Add(e.Options.Payload as ProductViewModel);
			}
		}

		#endregion

	}
}
